var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NativeComboBoxDelegate_1, NativeComboBox_1;
import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
export class ComboBoxChangeEvent extends Event {
    constructor(index, eventDict) {
        super('change', eventDict);
        this.index = index;
    }
}
let NativeComboBoxDelegate = NativeComboBoxDelegate_1 = class NativeComboBoxDelegate extends NSObject {
    static initWithOwner(owner) {
        const delegate = NativeComboBoxDelegate_1.new();
        delegate._owner = owner;
        return delegate;
    }
    comboBoxSelectionDidChange(_notification) {
        const owner = this._owner?.deref();
        if (owner) {
            owner.itemChange();
        }
    }
};
NativeComboBoxDelegate.ObjCProtocols = [NSComboBoxDelegate];
NativeComboBoxDelegate = NativeComboBoxDelegate_1 = __decorate([
    NativeClass
], NativeComboBoxDelegate);
export { NativeComboBoxDelegate };
let NativeComboBox = NativeComboBox_1 = class NativeComboBox extends NSComboBox {
    static initWithOwner(owner) {
        const combobox = NativeComboBox_1.new();
        combobox._owner = owner;
        return combobox;
    }
    itemChange() {
        const owner = this._owner?.deref();
        if (owner) {
            owner.dispatchEvent(new ComboBoxChangeEvent(this.indexOfSelectedItem));
        }
    }
    setItems(items) {
        this._items = items;
        this.removeAllItems();
        this.addItemsWithObjectValues(items);
        const owner = this._owner?.deref();
        if (owner) {
            if (typeof owner.selectedIndex === 'number') {
                this.selectItemAtIndex(owner.selectedIndex);
            }
        }
    }
};
NativeComboBox = NativeComboBox_1 = __decorate([
    NativeClass
], NativeComboBox);
export { NativeComboBox };
//# sourceMappingURL=native-combobox.js.map