var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import '@nativescript/macos-node-api';
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { ViewBase } from '../view/view-base.js';
import { Event } from '../../dom/dom-utils.js';
export class ImageLoadEvent extends Event {
    constructor(eventDict) {
        super('load', eventDict);
    }
}
export class ImageErrorEvent extends Event {
    constructor(eventDict) {
        super('error', eventDict);
    }
}
let Image = class Image extends ViewBase {
    constructor() {
        super(...arguments);
        this.nativeView = undefined;
    }
    get isLeaf() {
        // Text is always a leaf node.
        return true;
    }
    initNativeView() {
        this.nativeView = NSImageView.alloc().init();
        return this.nativeView;
    }
    setImage(value) {
        if (this.nativeView) {
            // @ts-expect-error it can be null
            this.nativeView.image = value;
            if (value) {
                this.dispatchEvent(new ImageLoadEvent());
            }
            else {
                this.dispatchEvent(new ImageErrorEvent());
            }
        }
    }
    applyLayout(parentLayout) {
        super.applyLayout(parentLayout);
        if (this.nativeView) {
            this.nativeView.translatesAutoresizingMaskIntoConstraints = true;
        }
    }
};
__decorate([
    native({
        setNative(view, _key, value) {
            let img;
            if (typeof value === 'string' && value?.indexOf('http') > -1) {
                img = NSImage.alloc().initWithContentsOfURL(NSURL.URLWithString(value));
            }
            else {
                img = NSImage.alloc().initWithContentsOfFile((value instanceof URL ? value.pathname : value).replace('file://', ''));
            }
            view.setImage(img);
        },
    }),
    __metadata("design:type", Object)
], Image.prototype, "src", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            const img = NSImage.imageWithSystemSymbolNameAccessibilityDescription(value, null);
            view.setImage(img);
        },
    }),
    __metadata("design:type", String)
], Image.prototype, "symbol", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                switch (value) {
                    case 'aspectFit':
                        view.nativeView.imageScaling = NSImageScaling.ImageScaleProportionallyUpOrDown;
                        break;
                    case 'fill':
                        view.nativeView.imageScaling = NSImageScaling.ImageScaleAxesIndependently;
                        break;
                    case 'fit':
                        view.nativeView.imageScaling = NSImageScaling.ScaleToFit;
                        break;
                    default:
                        view.nativeView.imageScaling = NSImageScaling.ScaleNone;
                        break;
                }
            }
        },
    }),
    __metadata("design:type", String)
], Image.prototype, "stretch", void 0);
Image = __decorate([
    view({
        name: 'HTMLImageElement',
        tagName: 'image',
    })
], Image);
export { Image };
//# sourceMappingURL=image.js.map