var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { native } from "../decorators/native.js";
import { view } from "../decorators/view.js";
import { ViewBase } from "../view/view-base.js";
let Menu = class Menu extends ViewBase {
    constructor() {
        super(...arguments);
        this.shouldAttachToParentNativeView = false;
        this._isEnabled = false;
        this._isIncludedInLayout = false;
    }
    initNativeView() {
        const menu = NSMenu.new();
        this.nativeView = menu;
        return this.nativeView;
    }
    addNativeChild(child) {
        if (child.nodeName !== "MENU-ITEM" &&
            child.nodeName !== "MENU-SEPARATOR" &&
            child.nodeName !== "MENU-SECTION-HEADER")
            return;
        this.nativeView.addItem(child.nativeView);
    }
    removeNativeChild(child) {
        this.nativeView.removeItem(child.nativeView);
    }
    open(event) {
        const view = this.parentNode?.nativeView;
        NSMenu.popUpContextMenuWithEventForView(this.nativeView, event, view);
    }
    disposeNativeView() {
        if (this.menuItem && this.attachToMainMenu) {
            NativeScriptApplication.appMenu.removeItem(this.menuItem);
        }
        super.disposeNativeView();
    }
};
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.title = value;
            }
        },
    }),
    __metadata("design:type", String)
], Menu.prototype, "title", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            NativeScriptApplication.createMenu();
            if (value) {
                if (!view.menuItem) {
                    view.menuItem = NSMenuItem.alloc().initWithTitleActionKeyEquivalent(view.nativeView.title, "", "");
                }
                view.menuItem.submenu = view.nativeView;
                NativeScriptApplication.appMenu.addItem(view.menuItem);
                view.menuItem.title = view.nativeView.title;
            }
            else {
                if (view.menuItem) {
                    NativeScriptApplication.appMenu.removeItem(view.menuItem);
                }
            }
        },
    }),
    __metadata("design:type", String)
], Menu.prototype, "attachToMainMenu", void 0);
Menu = __decorate([
    view({
        name: "HTMLMenuElement",
        tagName: "menu",
    })
], Menu);
export { Menu };
//# sourceMappingURL=menu.js.map