var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { ViewBase } from '../view/view-base.js';
const ProgressProperty = {
    setNative: (view, _key, value) => {
        if (view.nativeView) {
            view.nativeView.doubleValue = value;
        }
    },
    shouldLayout: true,
};
const IndeterminateProperty = {
    setNative: (view, _key, value) => {
        if (!view.nativeView)
            return;
        view.nativeView.isIndeterminate = value;
        if (value) {
            view.nativeView.startAnimation(view.nativeView);
        }
        else {
            view.nativeView.stopAnimation(view.nativeView);
        }
    },
    shouldLayout: true,
};
let Progress = class Progress extends ViewBase {
    get isLeaf() {
        return true;
    }
    initNativeView() {
        this.nativeView = NSProgressIndicator.alloc().init();
        return this.nativeView;
    }
    prepareNativeView(nativeView) {
        nativeView.style = NSProgressIndicatorStyle.Bar;
        nativeView.isIndeterminate = false;
    }
};
__decorate([
    native(ProgressProperty),
    __metadata("design:type", Number)
], Progress.prototype, "progress", void 0);
__decorate([
    native(IndeterminateProperty),
    __metadata("design:type", Boolean)
], Progress.prototype, "indeterminate", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.minValue = value;
            }
        },
    }),
    __metadata("design:type", Number)
], Progress.prototype, "minValue", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.maxValue = value;
            }
        },
    }),
    __metadata("design:type", Number)
], Progress.prototype, "maxValue", void 0);
__decorate([
    native({
        setNative(view, _key, value) {
            if (view.nativeView) {
                view.nativeView.style = value === 'bar' ? NSProgressIndicatorStyle.Bar : NSProgressIndicatorStyle.Spinning;
            }
        },
    }),
    __metadata("design:type", String)
], Progress.prototype, "type", void 0);
Progress = __decorate([
    view({
        name: 'HTMLProgressElement',
        tagName: 'progress',
    })
], Progress);
export { Progress };
//# sourceMappingURL=progress.js.map