import type { YogaNodeLayout } from "../../layout/index.js";
import type { Menu } from "../menu/menu.js";
import type { Popover } from "../popover/popover.js";
import { ViewBase } from "../view/view-base.js";
declare class MenuAction extends NSObject {
    static ObjCExposedMethods: {
        clicked: {
            returns: number;
            params: number[];
        };
    };
    owner?: WeakRef<StatusBar>;
    static initWithOwner(owner: WeakRef<StatusBar>): MenuAction;
    clicked(): void;
}
export declare class StatusBar extends ViewBase {
    nativeView?: NSStatusItem;
    shouldAttachToParentNativeView: boolean;
    isRoot: boolean;
    _popover?: Popover;
    _menu?: Menu;
    menuAction?: MenuAction;
    initNativeView(): NSStatusItem;
    insertBefore<T extends Node>(node: T, child: Node | null): T;
    addNativeChild(child: any): void;
    removeNativeChild(child: any): void;
    title: string;
    applyLayout(parentLayout?: YogaNodeLayout): void;
    disposeNativeView(): void;
}
export {};
