import '@nativescript/macos-node-api';
import { ViewBase } from '../view/view-base.js';
import { ImageLoadEvent } from '../image/image.js';
import { Event } from '../../dom/dom-utils.js';
export declare class ToolbarItemClickEvent extends Event {
    constructor(eventDict?: EventInit);
}
export declare class NativeToolbarItem extends NSToolbarItem {
    static ObjCExposedMethods: {
        click: {
            returns: number;
            params: number[];
        };
    };
    private _owner?;
    static initWithOwner(owner: WeakRef<ToolbarItem>): NativeToolbarItem;
    click(): void;
}
export declare class ToolbarItem extends ViewBase {
    nativeView?: NSToolbarItem;
    initNativeView(): NSToolbarItem | undefined;
    disposeNativeView(): void;
    onImageLoad?: (e: ImageLoadEvent) => void;
    addNativeChild(child: ViewBase): void;
    removeNativeChild(child: any): void;
    label: string;
    paletteLabel: string;
    title: string;
    toolTip: string;
    bordered: boolean;
    navigational: boolean;
    enabled: boolean;
}
