var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var NativeToolbarItem_1;
import '@nativescript/macos-node-api';
import { view } from '../decorators/view.js';
import { ViewBase } from '../view/view-base.js';
import { ImageLoadEvent } from '../image/image.js';
import { Event } from '../../dom/dom-utils.js';
import { native } from '../decorators/native.js';
export class ToolbarItemClickEvent extends Event {
    constructor(eventDict) {
        super('click', eventDict);
    }
}
let NativeToolbarItem = NativeToolbarItem_1 = class NativeToolbarItem extends NSToolbarItem {
    static initWithOwner(owner) {
        const item = NativeToolbarItem_1.alloc().initWithItemIdentifier(crypto.randomUUID());
        item._owner = owner;
        item.target = item;
        item.action = 'click';
        return item;
    }
    click() {
        const owner = this._owner?.deref();
        if (owner) {
            owner.dispatchEvent(new ToolbarItemClickEvent());
        }
    }
};
NativeToolbarItem.ObjCExposedMethods = {
    click: { returns: interop.types.void, params: [interop.types.id] },
};
NativeToolbarItem = NativeToolbarItem_1 = __decorate([
    NativeClass
], NativeToolbarItem);
export { NativeToolbarItem };
let ToolbarItem = class ToolbarItem extends ViewBase {
    constructor() {
        super(...arguments);
        this.nativeView = undefined;
    }
    initNativeView() {
        this.nativeView = NativeToolbarItem.initWithOwner(new WeakRef(this));
        return this.nativeView;
    }
    disposeNativeView() {
        this.nativeView = undefined;
    }
    addNativeChild(child) {
        if (child.nodeName === 'IMAGE') {
            if (this.nativeView) {
                this.onImageLoad = () => {
                    if (child.nativeView.image && this.nativeView) {
                        this.nativeView.image = child.nativeView.image;
                        this.nativeView.toolbar?.validateVisibleItems();
                    }
                };
                if (child.nativeView.image) {
                    this.onImageLoad(new ImageLoadEvent());
                }
                child.addEventListener('load', this.onImageLoad);
            }
        }
        else if (this.nativeView) {
            this.nativeView.view = child.nativeView;
        }
    }
    removeNativeChild(child) {
        if (child.nodeName === 'IMAGE') {
            if (this.nativeView) {
                // @ts-expect-error it can be null
                this.nativeView.image = null;
                if (this.onImageLoad) {
                    child.removeEventListener('load', this.onImageLoad);
                }
            }
        }
        else if (this.nativeView) {
            // @ts-expect-error it can be null
            this.nativeView.view = null;
        }
    }
};
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.label = value;
            }
        },
    }),
    __metadata("design:type", String)
], ToolbarItem.prototype, "label", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.paletteLabel = value;
            }
        },
    }),
    __metadata("design:type", String)
], ToolbarItem.prototype, "paletteLabel", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.title = value;
            }
        },
    }),
    __metadata("design:type", String)
], ToolbarItem.prototype, "title", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.toolTip = value;
            }
        },
    }),
    __metadata("design:type", String)
], ToolbarItem.prototype, "toolTip", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.isBordered = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], ToolbarItem.prototype, "bordered", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.isNavigational = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], ToolbarItem.prototype, "navigational", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.isEnabled = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], ToolbarItem.prototype, "enabled", void 0);
ToolbarItem = __decorate([
    view({
        name: 'HTMLToolbarItemElement',
        tagName: 'toolbar-item',
    })
], ToolbarItem);
export { ToolbarItem };
//# sourceMappingURL=toolbar-item.js.map