import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { YogaNodeLayout } from '../../layout/index.js';
import { View } from '../view/view.js';
export declare class WebviewNavigationEvent extends Event {
    url?: string | URL;
    navigationType?: WebViewNavigationType;
    constructor(type: string, url: string | URL, navigationType: WebViewNavigationType, eventDict?: EventInit);
}
export declare class LoadStartedEvent extends WebviewNavigationEvent {
    constructor(url: string | URL, navigationType: WebViewNavigationType, eventDict?: EventInit);
}
export declare class LoadFinishedEvent extends WebviewNavigationEvent {
    constructor(url: string | URL, eventDict?: EventInit);
}
type WebViewNavigationType = 'linkClicked' | 'formSubmitted' | 'backForward' | 'reload' | 'formResubmitted' | 'other' | undefined;
declare class WebViewDelegate extends NSObject implements WKUIDelegate, WKNavigationDelegate {
    static ObjCProtocols: (typeof WKUIDelegate | typeof WKNavigationDelegate)[];
    _owner: WeakRef<WebView>;
    static initWithOwner(owner: WeakRef<WebView>): WebViewDelegate;
    webViewCreateWebViewWithConfigurationForNavigationActionWindowFeatures(webView: WKWebView, _configuration: WKWebViewConfiguration, navigationAction: WKNavigationAction, _windowFeatures: WKWindowFeatures): WKWebView;
    webViewDecidePolicyForNavigationActionDecisionHandler(_webView: WKWebView, navigationAction: WKNavigationAction, decisionHandler: (p1: interop.Enum<typeof WKNavigationActionPolicy>) => void): void;
    webViewDidFinishNavigation(webView: WKWebView, _navigation: WKNavigation): void;
}
export declare class WebView extends View {
    get isLeaf(): boolean;
    delegate: WebViewDelegate;
    nativeView?: WKWebView;
    initNativeView(): WKWebView | undefined;
    applyLayout(parentLayout?: YogaNodeLayout): void;
    loadURL(value: string | URL): void;
    executeJavaScript(src: string): void;
    src: string | URL;
    debug: boolean;
}
export {};
